<div class="container" on:contextmenu|preventDefault>
    <div class="scroll" bind:this={ scrollEl } on:scroll={ setCurrPage }>
        <PdfRender
            pdfUrl={ file }
            bind:zoom
            bind:totalPages
            bind:isRendering
            bind:pagesEls
        />
    </div>

	<Controls 
		disabled={ isRendering }
		numPages={ totalPages }
		{ currentPage }
		{ zoom }
		on:pageChange = { onPageChange }
		on:zoomChange = { onZoomChange }
	/>
</div>

<svelte:window
	on:keydown={ handleKeydown }
	on:keyup={ handleKeyup }
/>

<script>
	import Controls from './components/Controls.svelte'
    import PdfRender from './components/PdfRender.svelte'
    
	// states
    export let file
    export let infos

	let totalPages = 0
	let zoom = 1
	let currentPage = 1
	let pagesEls = []
	let isRendering
	let scrollEl
    let ctrlDown = false
    
    $: infos = {
        totalPages,
        zoom,
        currentPage
    }
	
	function scrollToPage(pgNum) {
		const pgEl = pagesEls[pgNum-1]
		const offset = pgEl.offsetTop
		scrollEl.scrollTo(0, offset)
	}

	function setCurrPage() {
		let scrollPg = 1
		pagesEls.forEach((c, idx) => {
			if(c.getBoundingClientRect().y <= 1)
				scrollPg = idx + 1
		})
		if (scrollPg !== currentPage) {
			currentPage = scrollPg
		}
	}

	function onPageChange(ev) {
		scrollToPage(ev.detail.newPage)
	}

	function onZoomChange(ev) {
		zoom = ev.detail.newZoom
	}

	function handleKeydown(ev) {
		if (ev.key === 'Control') ctrlDown = true
		if (ctrlDown && (ev.key === 'f' || ev.key === 'a')) return
		if (ev.key === 'Enter') return
		if (ev.key.search(/^\d+$/) == 0) return
		ev.preventDefault()
		ev.stopPropagation()
	}
	
	function handleKeyup(ev) {
		if (ev.key === 'Control') ctrlDown = false
		if (ev.key === 'Enter') return
		ev.preventDefault()
		ev.stopPropagation()
	}
</script>

<style>
	.container {
		width: 100%;
        height: 100%;
        max-height: 100vh;
        overflow: hidden;
        position: relative;
        display: flex;
        flex-flow: column;
    }
    
    .scroll {
		scroll-behavior: smooth;
        width: 100%;
        height: 100%;
        overflow: auto;
    }
</style>